<?php

/*
Plugin Name: Dropdown Menu Manager
Plugin Description: Allows an administrator to select various categories to display in a dropdown menu
Version: 1.0
Author: Gorilla Themes
Author URI: http://www.gorillathemes.com/

*/


$no_of_dropdowns = 3;

//Various Wordpress hooks
add_action('admin_menu', 'dropdown_manager_addmenuitems');
register_activation_hook( __FILE__ , 'dropdown_manager_install' );

//add items to theme options menu
function dropdown_manager_addmenuitems()
{
	add_menu_page('Search Selector', 'Search Selector', 1, __FILE__, 'dropdown_manager_show');
	
}

//this controls the theme options page
function theme_options (){
echo 'Welcome to your custom theme options page, Use the links above to control your options';
}


//this gets the # of dropdowns allowed
function dropdown_get_dropdowns()
{
	global $wpdb;
	
	$sql = "SELECT `value` as `dropdowns` FROM `" . $wpdb->prefix . "dropdown_plugin_settings` WHERE `name`='total_dropdowns';";
	$row = $wpdb->get_results ( $sql , OBJECT );
	
	return $row[0]->dropdowns;
}

//this is the function that actually shows the dropdown menu
function dropdown_manager_paintdropdown( $num )
{
	global $wpdb;
	
	//get all categories that are enabled for dropdown
	$wpdb->show_errors();
	
	$sql = "SELECT `terms`.`term_id` as `term_id`, `terms`.`name` as `name`
			FROM `" . $wpdb->prefix . "terms` as `terms`
			LEFT JOIN `" . $wpdb->prefix . "dropdown_plugin_dropdowns` as `dropdown`
			ON ( `dropdown`.`term_id` = `terms`.`term_id` )
			WHERE `dropdown`.`menu` = '" . (int)$num . "';";
	
	$rows = $wpdb->get_results ( $sql, OBJECT );
	
	//print out a drop down
	echo '<select name="gotoCategory" onchange="document.location.href=this.options[this.selectedIndex].value;"><option value="">' . attribute_escape(__('Select Category')) . '</option>';
	
	
	//go through the categories, and print out an option
		$blogurl = get_bloginfo('url');

			if ( $rows )
	{
		foreach ( $rows as $row )
		{
			$option = '<option value="'. $blogurl .'/?cat=' . $row->term_id . '">' . $row->name . '</option>';
			echo $option;
		}
	}	
	//echo out the end of the select
	echo '</select>';
}

//this is the control for the dropdown menu
function dropdown_manager_show()
{
	global $wpdb;
	
	$no_of_dropdowns = dropdown_get_dropdowns();
	
	$wpdb->show_errors();
	
	//user pressed "change"
	if ( isset ( $_POST['submit'] ) )
	{
		$sql = "UPDATE `" . $wpdb->prefix . "dropdown_plugin_settings` SET `value`='" . (int)$_POST['total_dropdowns'] . "' WHERE `name`='total_dropdowns';";
		$wpdb->query ( $sql);
		
		$no_of_dropdowns = (int)$_POST['total_dropdowns'];
		
		//delete all the dropdows selected
		$sql = "TRUNCATE `" . $wpdb->prefix . "dropdown_plugin_dropdowns`";
		$wpdb->query ( $sql );
		
		for ( $i = 0; $i < $no_of_dropdowns; $i++ )
		{	
			if ( is_array ( $_POST['terms_' . $i ] ) && !empty ( $_POST['terms_' . $i ] ) )
			{
				//Enable each of the categories selected.
				foreach ( $_POST['terms_' . $i ] as $key=>$value )
				{
					$wpdb->show_errors();
					$sql = "INSERT INTO " . $wpdb->prefix . "dropdown_plugin_dropdowns ( `term_id`, `menu` ) VALUES ( '" . (int)$value . "', '" . $i . "' )";
					$wpdb->query ( $sql );
				}
			}
		} //end updaing the categories
	}
	
	echo '
	<style type="text/css">
	.formclass1
	{
		margin: 10px;
		display: inline-block;
		padding: 5px;
		border: 1px solid #999999;
		padding-left: 10px;
		background-color: #F9F9FF;
	}
	#leftbuttons
	{
		text-align: left;
		margin-top: 10px;
		margin-left: 10px;
	}
	
	#settings
	{
		margin-top: 10px;
		margin-left: 10px;
	}
	</style>
	
	<form action="' . $PHP_SELF . '" method="post">';
	
	for ( $menu = 0; $menu < $no_of_dropdowns; $menu++ )
	{
		//echo out form details
		echo '<span class="formclass1">';
		echo '<strong>Categories for Menu ' . ( $menu + 1 ) . ':</strong><br/><br/>';
		
		//get all of the categories from the db
		$sql = "SELECT `terms`.`term_id` as `term_id`, `terms`.`name` as `name`, `terms`.`slug` as `slug`
					FROM `" . $wpdb->prefix . "terms` as `terms` LEFT JOIN `" . $wpdb->prefix . "term_taxonomy` as `tax`
					ON ( `terms`.`term_id` = `tax`.`term_id` ) 

					WHERE `tax`.`taxonomy` = 'category' 
					ORDER BY terms.name ASC;";
				
		$rows = $wpdb->get_results ( $sql, OBJECT );
		
		$sql = "SELECT * FROM `" . $wpdb->prefix . "dropdown_plugin_dropdowns`;";

		$selected = $wpdb->get_results ( $sql, OBJECT );
		
		//If there are any categories
		if ( $rows )
		{
			//go through each of them
			foreach ( $rows as $row )
			{
				//and check it wether or not it's enabled
				$checked = '';
				
				foreach ( $selected as $sel )
				{
					if ( $sel->menu == $menu && $sel->term_id == $row->term_id )
					{
						$checked =  ' checked="checked"';
					}
				}
				
				echo '<input type="checkbox" name="terms_' . $menu . '[]" value="' . $row->term_id . '"' . $checked . '/>' . $row->name . '<br/>';
	
			}
		}
		
		echo '</span>';
	}
	
	echo '<div id="settings"><br>Number of dropdown menus: <select name="total_dropdowns">';
	
	for ( $i = 1; $i <= 15; $i++ )
	{
		echo '<option value="'. $i . '"' . ( $i == $no_of_dropdowns ? ' selected="selected"' : '' ) .  '>' . $i . '</option>';
	}
	
	echo '</select></div>';
	
	echo '<div id="leftbuttons"><input class="button" type="submit" name="submit" value="Submit"/><input class="button" type="reset" value="Reset"/></div></form>';
	
	//sample dropdown menu
	echo '<div style="padding:10px;"><br/><br/><br/>Sample DropDown Menus:<br/><br/>';
	
	//the actual dropdown menu
	for ( $i = 0; $i < $no_of_dropdowns; $i++ )
	{
		dropdown_manager_paintdropdown( $i );
	}
	echo '</div>';
}

//this function takes care of altering the categories table with a dropdown column
function dropdown_manager_install()
{
	global $wpdb;

	$sql = "CREATE TABLE `" . $wpdb->prefix . "dropdown_plugin_settings` ( `setting_id` MEDIUMINT NOT NULL AUTO_INCREMENT PRIMARY KEY, `name` VARCHAR(255) NOT NULL, `value` VARCHAR(255) NOT NULL )"; 
	$wpdb->query ( $sql );
	
	
	$sql = "CREATE TABLE `" . $wpdb->prefix . "dropdown_plugin_dropdowns` ( `dropdown_id` MEDIUMINT NOT NULL AUTO_INCREMENT PRIMARY KEY, `term_id` MEDIUMINT NOT NULL, `menu` MEDIUMINT NOT NULL )";
	$wpdb->query ( $sql );
	
	$sql = "INSERT INTO `" . $wpdb->prefix . "dropdown_plugin_settings` ( `name`, `value` ) VALUES ( 'total_dropdowns', '3' );";
	$wpdb->query ( $sql );
}

?>