<?php
/*
Plugin Name: Real Estate Dream
Plugin URI: http://gorillathemes.com
Description: List and manage your real estate listings with ease using WordPress 2.7+
Author: Gorilla Themes
Version: 2.0
Author URI: http://gorillathemes.com/
This plugin is Copyright 2009 Gorilla Themes. All rights reserved.
*/




// Pre-2.6 compatibility
if ( !defined('WP_CONTENT_URL') ) {
    define( 'WP_CONTENT_URL', get_option('siteurl') . '/wp-content');
    }
if ( !defined('WP_CONTENT_DIR') ) {
    define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
    }
 
// Guess the location
$plugin_path = WP_CONTENT_DIR.'/plugins/'.plugin_basename(dirname(__FILE__));
$plugin_url = WP_CONTENT_URL.'/plugins/'.plugin_basename(dirname(__FILE__));

if (re_dream_islisting() == 1) {  // if we're editing a real estate listing
    add_filter('edit_form_advanced', 'red_customscreen');  //install the custom write-post screen
    add_action('admin_head', 'red_adminheader'); //Admin header info for custom write-post screen
}
add_action('admin_menu', 're_dream_addmenu');  //installs the menu buttons
//add the custom fields when the post is edited, saved, or published
add_action('edit_post', 'red_add_fields');
add_action('publish_post', 'red_add_fields');
add_action('save_post', 'red_add_fields');
 

function red_adminheader() { //add Javascript function into admin header
          //javascript used to show/hide divs for upload forms
          echo "<script type='text/javascript'>
                /* <![CDATA[ */
                var state = 'shown'; 
                function showhide(layer_ref) { 
                    if (state == '') { 
                    state = 'none'; 
                      } 
                    else { 
                      state = ''; 
                      } 
                    if (document.all) { //IS IE 4 or 5 (or 6 beta) 
                      eval( \"document.all.\" + layer_ref + \".style.display = state\"); 
                      } 
                    if (document.layers) { //IS NETSCAPE 4 or below 
                      document.layers[layer_ref].display = state; 
                      } 
                    if (document.getElementById &&!document.all) { 
                      hza = document.getElementById(layer_ref); 
                      hza.style.display = state; 
                    } 
                  }
                  function deleteMe(id_ref) {
                      var theImage = document.getElementById(id_ref);
                      theImage.value = \"\";
                      } 
                /* ]]> */ 
                </script>" . "\n";  //script info for AJAX-esque upload
}

function red_customscreen(){  //displays the form in the custom write post screen
    global $post;
    global $plugin_url;
    
    $price = get_post_meta($post->ID, 'price', true);
    $listing = get_post_meta($post->ID, 'listing', true);
    $property = get_post_meta($post->ID, 'property', true);
    $address = get_post_meta($post->ID, 'address', true);
    $city = get_post_meta($post->ID, 'city', true);
    $state = get_post_meta($post->ID, 'state', true);
    $zip = get_post_meta($post->ID, 'zip', true);
    $bed = get_post_meta($post->ID, 'bedrooms', true); 
    $bath = get_post_meta($post->ID, 'bathrooms', true);
    $sqft = get_post_meta($post->ID, 'sqft', true);       
    $school = get_post_meta($post->ID, 'school', true);
    $mlsurl = get_post_meta($post->ID, 'mlsurl', true);
    $mlsinfo = get_post_meta($post->ID, 'mlsinfo', true);
    $features = get_post_meta($post->ID, 'features', true);
    $water = get_post_meta($post->ID, 'water', true);
    $image1 = get_post_meta($post->ID, 'red_image1', true);
    $image2 = get_post_meta($post->ID, 'red_image2', true);
    $image3 = get_post_meta($post->ID, 'red_image3', true);
    $image4 = get_post_meta($post->ID, 'red_image4', true);
    $image5 = get_post_meta($post->ID, 'red_image5', true);
    $image6 = get_post_meta($post->ID, 'red_image6', true);
    $image7 = get_post_meta($post->ID, 'red_image7', true);
    $image8 = get_post_meta($post->ID, 'red_image8', true);
    $image9 = get_post_meta($post->ID, 'red_image9', true);
    $image10 = get_post_meta($post->ID, 'red_image10', true);
    $image11 = get_post_meta($post->ID, 'red_image11', true);
    $image12 = get_post_meta($post->ID, 'red_image12', true);
    $image13 = get_post_meta($post->ID, 'red_image13', true);
    $image14 = get_post_meta($post->ID, 'red_image14', true);
    $listing_types = array('For Sale', 'For Rent', 'For Lease', 'Auction');
    $property_types = array('Single Family', 'Townhome or Condo', 'Multi-Family', 'Duplex', 'Commercial', 'Lots and Land');
?>


<style>
input[type=text]{width: 200px;}
textarea{width: 300px;}
</style>


  <h2>Real Estate Dream Options</h2>
  
  <div class="postbox">
	   <h3 style="font-weight: normal;">General Listing Info</h3>
       <div class="inside">
        <table style="text-align: left;">
          <input value="1" type="hidden" name="isrealestate" />  
		     <tr>
		      <td>Price:</td>
          <td><big>$</big><input type="text" name="price" id="price" value="<?php echo $price; ?>"  size="12"><small> Exclude the dollar sign when entering</small></td>
        </tr>
        <tr>
          <td>Listing Type:</td>
          <td><select style="width: 150px;" name="listing">
		      <?php foreach ($listing_types as $type){ 
              print '<option value="' . $type . '"';
              if ($type == $listing){
                print ' selected="selected"';
                }
              print "> $type</option>\n";
            } ?>
            </select>
          </td>
		     </tr>
		     <tr>
		      <td>Property Type:</td>
		      <td><select name="property" style="width: 150px;">
		      <?php foreach ($property_types as $type){
              print '<option value="' . $type . '"';
              if ($type == $listing){
                print ' selected="selected"';
                }
              print "> $type</option>\n";
            } ?>
            </select>
            
          </td>
		   </table>
		  </div>
   </div>
  
   <div class="postbox">
	  <h3 style="font-weight: normal;">Property Address</h3>
       <div class="inside">
        <table style="text-align: left;">
        <tr>
		      <td><input type="text" name="address" id="address" value="<?php echo $address; ?>"  scrolling="auto" cols="50" rows="4">
            <td valign="middle" style="font-size: 11px;">Street Address</td>
          </td>
		    </tr>
		    <tr>
		      <td><input type="text" name="city" id="city" value="<?php echo $city; ?>"  scrolling="auto" cols="50" rows="4">
            <td valign="middle" style="font-size: 11px;">City</td> 
          </td>
        </tr>
        <tr>
        <td><input type="text" name="state" id="state" value="<?php echo $state; ?>"  scrolling="auto" cols="50" rows="4">
            <td valign="middle" style="font-size: 11px;">State</td>
            <td style="float: left;"><input type="text" name="zip" id="zip" value="<?php echo $zip; ?>"  scrolling="auto" size="4">
            <td valign="middle" style="font-size: 11px; text-align: left;">Zip code</td>  
         </td>  
         </td> 
		    </table>
		   </div>
  </div>

  <div class="postbox">
	   <h3 style="font-weight: normal;">Detailed Info</h3>
       <div class="inside">
        <table style="text-align: right;" valign="top">  
		     <tr>
          <td> Bedrooms:</td>
          <td style="text-align: left;"><input type="text" name="bedrooms" id="bedrooms" value="<?php echo $bed; ?>" size="3"></td>
          <td>School District: </td>
          <td style="text-align: left;"><input type="text" name="school" id="school" value="<?php echo $school; ?>" size="30"></td> 
        </tr>
        <tr>
          <td> Bathrooms:</td>
          <td style="text-align: left;"><input type="text" name="bathrooms" id="bathrooms" value="<?php echo $bath; ?>" size="3"></td>
          <td> MLS Link:</td>
          <td style="text-align: left;"><input type="text" name="mlsurl" id="mlsurl" value="<?php echo $mlsurl; ?>" size="30"></td>
        </tr>
        <tr>
          <td> Bldg/Land Sq Feet:</td>
          <td style="text-align: left;"><input type="text" name="sqft" id="sqft" value="<?php echo $sqft; ?>" size="3"></td>
          <td> MLS Info:</td>
          <td style="text-align: left;"><textarea name="mlsinfo" cols="29" rows="3"><?php echo $mlsinfo; ?></textarea></td>
        </tr></table>
        <table>
        <tr>
        <td>Waterfront Property:</td>
         <td><input type="radio" name="water" value="Yes" <?php if ($water == "Yes") {echo "checked"; } ?> > Yes <input type="radio" name="water" value="No" <?php if ($water == "No") {echo "checked"; } ?> > No </td>
         </tr>
        <tr>
         <td style="padding-left: 60px;">Features:</td>
         <td style="text-align: left;"><textarea name="features" cols="51" rows="5"><?php echo $features; ?></textarea> 
      </table>
		</div>
  </div>  
   
   <div class="postbox">
	 
	   <h3 style="font-weight: normal;">Images (up to 14)</h3>
       <div class="inside">
      
  
  <table  valign="middle">
      <tr><td><input type="text" size="50" name="image1" id="image1" value="<?php echo $image1 ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image1up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image1');" style="cursor: pointer;">Delete</a></td></tr>
         <table style="margin-top: 10px;"  valign="middle">    <tr> <td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image1up" >
                      <iframe name="image1frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=1';?>" ></iframe>
                      </p> </td></tr>
        </table></table>
      <table>
         <tr >              
           <td><input type="text" size="50" name="image2" id="image2" value="<?php echo $image2; ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image2up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image2');" style="cursor: pointer;">Delete</a></td></tr>  
              <table><tr><td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image2up">
                      <iframe name="image2frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=2';?>" ></iframe>
                      </p> </td></tr></table></table>
     <table>   <tr>   
           <td><input type="text" size="50" name="image3" id="image3" value="<?php echo $image3; ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image3up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image3');" style="cursor: pointer;">Delete</a></td></tr>       
             <table><tr><td> <p style="margin-left: -15px; margin-top: -15px; display: none;" id="image3up">
                      <iframe name="image3frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=3';?>" ></iframe>
                      </p> </td></tr>  </table>      </table>   
       <table> <tr>             
           <td><input type="text" size="50" name="image4" id="image4" value="<?php echo $image4; ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image4up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image4');" style="cursor: pointer;">Delete</a></td></tr>  
              <table><tr><td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image4up">
                      <iframe name="image4frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=4';?>" ></iframe>
                      </p> </td></tr> </table>
          </tr></table>
        <table  valign="middle">
      <tr><td><input type="text" size="50" name="image5" id="image5" value="<?php echo $image5 ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image5up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image5');" style="cursor: pointer;">Delete</a></td></tr>
         <table style="margin-top: 10px;"  valign="middle">    <tr> <td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image5up" >
                      <iframe name="image5frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=5';?>" ></iframe>
                      </p> </td></tr>
        </table></table>
          <table  valign="middle">
      <tr><td><input type="text" size="50" name="image6" id="image6" value="<?php echo $image6 ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image6up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image6');" style="cursor: pointer;">Delete</a></td></tr>
         <table style="margin-top: 10px;"  valign="middle">    <tr> <td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image6up" >
                      <iframe name="image6frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=6';?>" ></iframe>
                      </p> </td></tr>
        </table></table>
          <table  valign="middle">
      <tr><td><input type="text" size="50" name="image7" id="image7" value="<?php echo $image7 ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image7up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image7');" style="cursor: pointer;">Delete</a></td></tr>
         <table style="margin-top: 10px;"  valign="middle">    <tr> <td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image7up" >
                      <iframe name="image7frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=7';?>" ></iframe>
                      </p> </td></tr>
        </table></table>
          <table  valign="middle">
      <tr><td><input type="text" size="50" name="image8" id="image8" value="<?php echo $image8 ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image8up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image8');" style="cursor: pointer;">Delete</a></td></tr>
         <table style="margin-top: 10px;"  valign="middle">    <tr> <td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image8up" >
                      <iframe name="image8frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=8';?>" ></iframe>
                      </p> </td></tr>
        </table></table>
          <table  valign="middle">
      <tr><td><input type="text" size="50" name="image9" id="image9" value="<?php echo $image9 ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image9up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image9');" style="cursor: pointer;">Delete</a></td></tr>
         <table style="margin-top: 10px;"  valign="middle">    <tr> <td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image9up" >
                      <iframe name="image9frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=9';?>" ></iframe>
                      </p> </td></tr>
        </table></table>
          <table  valign="middle">
      <tr><td><input type="text" size="50" name="image10" id="image10" value="<?php echo $image10 ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image10up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image10');" style="cursor: pointer;">Delete</a></td></tr>
         <table style="margin-top: 10px;"  valign="middle">    <tr> <td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image10up" >
                      <iframe name="image10frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=10';?>" ></iframe>
                      </p> </td></tr>
        </table></table>
          <table  valign="middle">
      <tr><td><input type="text" size="50" name="image11" id="image11" value="<?php echo $image11 ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image11up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image11');" style="cursor: pointer;">Delete</a></td></tr>
         <table style="margin-top: 10px;"  valign="middle">    <tr> <td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image11up" >
                      <iframe name="image11frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=11';?>" ></iframe>
                      </p> </td></tr>
        </table></table>
          <table  valign="middle">
      <tr><td><input type="text" size="50" name="image12" id="image12" value="<?php echo $image12 ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image12up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image12');" style="cursor: pointer;">Delete</a></td></tr>
         <table style="margin-top: 10px;"  valign="middle">    <tr> <td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image12up" >
                      <iframe name="image12frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=12';?>" ></iframe>
                      </p> </td></tr>
        </table></table>
          <table  valign="middle">
      <tr><td><input type="text" size="50" name="image13" id="image13" value="<?php echo $image13 ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image13up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image13');" style="cursor: pointer;">Delete</a></td></tr>
         <table style="margin-top: 10px;"  valign="middle">    <tr> <td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image13up" >
                      <iframe name="image13frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=13';?>" ></iframe>
                      </p> </td></tr>
        </table></table>
          <table  valign="middle">
      <tr><td><input type="text" size="50" name="image14" id="image14" value="<?php echo $image14 ?>"><p style="margin-top: 0px;">Enter url or upload a new image</p></td><td valign="top"><a onclick="showhide('image14up');" style="cursor: pointer;">Upload</a> / <a onclick="deleteMe('image14');" style="cursor: pointer;">Delete</a></td></tr>
         <table style="margin-top: 10px;"  valign="middle">    <tr> <td><p style="margin-left: -15px; margin-top: -15px; display: none;" id="image14up" >
                      <iframe name="image14frame" style="border: none; width: 500px; height: 115px;" scrolling="no" src="<?php echo $plugin_url.'/upload/index.php?img=14';?>" ></iframe>
                      </p> </td></tr>
        </table></table>

        </div>
      </div>       
    <?php
    }


function red_add_fields($id){  //saves the custom fields and processes the URL for the uploads
    
    $isrealestate = stripslashes($_POST["isrealestate"]);
    $price = stripslashes($_POST["price"]);  
    $listing = stripslashes($_POST["listing"]);
    $property = stripslashes($_POST["property"]);
    $address = stripslashes($_POST["address"]);
    $city = stripslashes($_POST["city"]);
    $state = stripslashes($_POST["state"]);
    $zip = stripslashes($_POST["zip"]);
    $bed = stripslashes($_POST["bedrooms"]);
    $bath = stripslashes($_POST["bathrooms"]);
    $sqft = stripslashes($_POST["sqft"]);
    $school = stripslashes($_POST["school"]);
    $mlsurl = stripslashes($_POST["mlsurl"]);
    $mlsinfo = stripslashes($_POST["mlsinfo"]);
    $water = stripslashes($_POST["water"]);
    $features = stripslashes($_POST["features"]);
    $image1 = stripslashes($_POST["image1"]);
    $image2 = stripslashes($_POST["image2"]);
    $image3 = stripslashes($_POST["image3"]);
    $image4 = stripslashes($_POST["image4"]);
    $image5 = stripslashes($_POST["image5"]);
    $image6 = stripslashes($_POST["image6"]);
    $image7 = stripslashes($_POST["image7"]);
    $image8 = stripslashes($_POST["image8"]);
    $image9 = stripslashes($_POST["image9"]);
    $image10 = stripslashes($_POST["image10"]);
    $image11 = stripslashes($_POST["image11"]);
    $image12 = stripslashes($_POST["image12"]);
    $image13 = stripslashes($_POST["image13"]);
    $image14 = stripslashes($_POST["image14"]);

  if (isset($isrealestate) && !empty($isrealestate)) {  //if the forms been submitted
    
    delete_post_meta($id, 'isrealestate');
    add_post_meta($id, 'isrealestate', $isrealestate);
  
  //first lets delete all the data that's already stored in the database. This makes sure content isn't duplicated
    delete_post_meta($id, 'price');
    delete_post_meta($id, 'listing');
	delete_post_meta($id, 'property');
  	delete_post_meta($id, 'address');
    delete_post_meta($id, 'city');
    delete_post_meta($id, 'state');
    delete_post_meta($id, 'zip');
    delete_post_meta($id, 'bedrooms');
    delete_post_meta($id, 'bathrooms');
    delete_post_meta($id, 'sqft');
    delete_post_meta($id, 'school');
    delete_post_meta($id, 'mlsurl');
    delete_post_meta($id, 'mlsinfo');
    delete_post_meta($id, 'water');
    delete_post_meta($id, 'features');
    delete_post_meta($id, 'red_image1');
    delete_post_meta($id, 'red_image2');
    delete_post_meta($id, 'red_image3');
    delete_post_meta($id, 'red_image4');
    delete_post_meta($id, 'red_image5');
    delete_post_meta($id, 'red_image6');
    delete_post_meta($id, 'red_image7');
    delete_post_meta($id, 'red_image8');
    delete_post_meta($id, 'red_image9');
    delete_post_meta($id, 'red_image10');
    delete_post_meta($id, 'red_image11');
    delete_post_meta($id, 'red_image12');
    delete_post_meta($id, 'red_image13');
    delete_post_meta($id, 'red_image14');
  
  //now lets add whatever was listed in the custom-write screen
      add_post_meta($id, 'price', $price);
      add_post_meta($id, 'listing', $listing);
	  add_post_meta($id, 'property', $property);
	  add_post_meta($id, 'address', $address);
	  add_post_meta($id, 'city', $city);
	  add_post_meta($id, 'state', $state);
	  add_post_meta($id, 'zip', $zip);
	  add_post_meta($id, 'bedrooms', $bed);
	  add_post_meta($id, 'bathrooms', $bath);
	  add_post_meta($id, 'sqft', $sqft);
	  add_post_meta($id, 'school', $school);
	  add_post_meta($id, 'mlsurl', $mlsurl);
	  add_post_meta($id, 'mlsinfo', $mlsinfo);
	  add_post_meta($id, 'water', $water);
	  add_post_meta($id, 'features', $features);
	//the images
	  add_post_meta($id, 'red_image1', $image1); 
      add_post_meta($id, 'red_image2', $image2);
      add_post_meta($id, 'red_image3', $image3);
      add_post_meta($id, 'red_image4', $image4);
      add_post_meta($id, 'red_image5', $image5);
      add_post_meta($id, 'red_image6', $image6);
      add_post_meta($id, 'red_image7', $image7);
      add_post_meta($id, 'red_image8', $image8);
      add_post_meta($id, 'red_image9', $image9);
      add_post_meta($id, 'red_image10', $image10);
      add_post_meta($id, 'red_image11', $image11);
      add_post_meta($id, 'red_image12', $image12);
      add_post_meta($id, 'red_image13', $image13);
      add_post_meta($id, 'red_image14', $image14);
    
  //redirect to a new "Add Listing" page
    //  add_action('save_post', 're_dream_redirect');      
  }
}

function re_dream_redirect($post_id){
  $post = get_post($post_id);
  
  if (($post->post_type == 'post') && ($post->post_status == 'publish')) {
     $location = get_bloginfo('wpurl') . '/wp-admin/post-new.php?ref=red';
	   wp_redirect($location);
	   exit();
    }  
}


function re_dream_islisting(){  //checks if the post ID or page is meant to be a real estate listing
    $id = $_GET['post'];
    $ref = $_GET['ref'];
    $is_realestate = get_post_meta($id, 'isrealestate', $single = true);  //is the "isproduct" meta-key set
    
    
    if (($ref == "red") || ($is_realestate == 1)) {
         return 1;  //yup, must be a real estate listing
      }
    else {
        return 0;  //nope, shouldn't be a real estate listing
      }
}

function re_dream_addmenu(){  //Let's add some menu buttons
    add_submenu_page('post.php','Add Listing', 'Add Listing', 8, 'post-new.php?ref=red');  //add the sublevel button on the Write screen
    add_menu_page('Real Estate', 'Add Listing', 8, 'post-new.php?ref=red'); //add the top level menu button
}


////////////////////////////////////
//        Manage Listings         //
////////////////////////////////////

function re_dream_managetab(){  //adds the Product managment link under "manage"

    if ($_GET['mng'] == 'listing'){  
          $style = "class=\"current\"";
          }
    $url = "<a href=\"".get_option( 'siteurl' ) ."/wp-admin/edit.php?mng=listing\"" . $style .">Listings</a>";
    
 add_management_page('Listings', $url, 8, __FILE__, $url);
 }
 add_action('admin_menu', 're_dream_managetab');  
 
 add_filter('manage_posts_columns', 're_dream_remove_columns');
function re_dream_remove_columns($defaults) {  //let's remove some un-needed columns if it's a post
    if( $_GET['mng'] == 'listing' ) {
      unset($defaults['comments']);
      unset($defaults['author']);
      unset($defaults['tags']);
      unset($defaults['categories']);
      unset($defaults['status']);
      unset($defaults['title']);
    }
  return $defaults;
    
}

add_filter('manage_posts_columns', 're_dream_columns');
add_action('manage_posts_custom_column', 're_dream_custom_column', 10, 2);

function re_dream_columns($defaults) {  //adds column names for posts
  if( $_GET['mng'] == 'listing' ) {
      $defaults['title'] = 'Title';
      $defaults['image'] = 'Image';
      $defaults['info'] = 'Listing Info';

      $defaults['status'] = 'Status';
      }
  else{
      $defaults['isrealestate'] = '<center>Real Estate Listing?</center>';  //ad the real estate column to the normal post lists
    }
return $defaults;  
}

function re_dream_custom_column($column_name, $post_id) {   //defines what goes in the new columns
      global $wpdb;
      global $plugin_url;

     
   
    if( $column_name == 'isrealestate' ) {  // the "Is Real Estate" Column
      $isrealestate = get_post_meta($post_id, 'isrealestate', true);
      
      if ($isrealestate){
        echo 'YES';
        }
      }
    if( $column_name == 'info' ) {
         $price = get_post_meta($post_id, 'price', true);
         $address = get_post_meta($post_id, 'address', true);
         $city = get_post_meta($post_id, 'city', true);
         $state = get_post_meta($post_id, 'state', true);
         $zip = get_post_meta($post_id, 'zip', true);
         $listing = get_post_meta($post_id, 'listing', true);
         $property = get_post_meta($post_id, 'property', true);
        
        $output = "$address <br />";
        
        if($city){
          $output .= $city . ", ";
          }
        
        $output .= $state ." " . $zip;
        
        if($price){
          $output .= "<br /><br /> <strong>Price</strong>: &#36;$price";
            }
        
        if($listing){
          $output .= "<br /> <strong>Listing Type</strong>: $listing";
          }
        if($property){
          $output .= "<br /> <strong>Property Type</strong>: $property";
          }
        
         echo $output;

          } 
        
  if( $column_name == 'image' ) {
    $image = get_post_meta($post_id, 'red_image1', true);
      if ($image){
        
         echo "<a href=\"{$image}\"><img src=\"{$plugin_url}/timthumb.php?src={$image}&w=220&h=130&zc=1\" /></a><br />";
          
        
          for ($i = 1, $a = 0; $i <= 14; $i++){
          $test = get_post_meta($post_id, "red_image$i", true);
           if($test){
              $a++;
              }
          }
          echo "$a of 5 Images Uploaded";
          }
        else {
          $image = $plugin_url . "/noimage.jpg"; 
          echo "<a href=\"{$image}\"><img src=\"{$plugin_url}/timthumb.php?src={$image}&w=220&h=130&zc=1\" /></a>"; } 
      }
}

/**
 * Join with the postmeta table to check for the listing metakeys.
 */
add_action('load-edit.php', 're_dream_init_attachments');

function re_dream_init_attachments() {
    add_filter('posts_join', 're_dream_posts_join');
    add_action('restrict_manage_posts', 're_dream_restrict_manage_posts');
}

function re_dream_posts_join($join) {
	global $wpdb;

    if( $_GET['mng'] == 'listing' ) {
		$join .= " JOIN $wpdb->postmeta";
		$join .= " ON $wpdb->posts.ID = $wpdb->postmeta.post_id";
		$join .= " AND ($wpdb->postmeta.meta_key = 'isrealestate')";
	} 
	return $join;
}

function re_dream_restrict_manage_posts() {
  global $wp_version;
  if ($wp_version >= "2.5"){
    ?>
	<select name='mng' id='mng' class='postform'>
		<option value="0"><?php _e('View all posts and listings') ?></option>
		<option value="listing" <?php if( isset($_GET['mng']) && $_GET['mng']=='listing') echo 'selected="selected"' ?>><?php _e('View only Listings'); ?></option>

	</select>
<?php
  } 
}
?>